//-----------------------------------------------------------------------------
//	FWCyPart.h
//	Support for FW_OCyberPartExtension. Wraps it so that the developer
//	never needs to deal with SOM. Also implements basic recipes.
//	
//	Copyright (c) 1995 - 1996 by Apple Computer, Inc., all rights reserved.
//-----------------------------------------------------------------------------

#ifndef _FW_MCyberPart_
#define _FW_MCyberPart_

#include "SLCyPart.h"
#include "SLCyPart.xh"
#include <CyberItem.xh>
class FW_CPart;
class FW_CEventDispatcher;

typedef FW_TAcquiredODRefCntObject<ODF_FW_OCyberPartExtension> FW_CAcquiredODFCyberPartExtension;

class FW_MCyberPart: public FW_SCyberPartExtensionCallbacks {
public:
						FW_MCyberPart (FW_CPart* part);
						~FW_MCyberPart ();
	void 				Initialize (Environment* ev);
	
	// API
	CyberItem* 			GetCyberItem();
	CyberSession* 		GetCyberSession();
	CyberPartExtension* AcquireCyberExtension();
	FW_CEventDispatcher* MakeEventDispatcher (Environment *ev);
	
	// CyberPartExtension <CyberPartExtension.idl>
	enum { FW_kHandledCyberCommand = true, FW_kPassCyberCommand = false };
	virtual void 		HandleOpenCyberItem (Environment* ev, CyberItem* item, ODPart* openerPart, ParameterSet* parameters);
	virtual void 		DoSetCyberItem 		(Environment* ev, CyberItem* newItem, ParameterSet* parameters);
	virtual ODBoolean 	DoCanShowCyberItem 	(Environment* ev, CyberItem* item);
	virtual void 		DoShowCyberItem 	(Environment* ev, CyberItem* item);
	virtual ODWindow* 	DoGetCyberItemWindow (Environment* ev, CyberItem* item);
	virtual ODBoolean 	DoIsCyberItemSelected (Environment* ev, ODFrame* frame);
	virtual void 		DoAcquireSelectedCyberItems (Environment* ev, ODFrame* frame, CyberItemList* items);
	virtual ODBoolean 	DoIsURLSelected 	(Environment* ev, ODFrame* frame);
	virtual void 		DoGetSelectedURL 	(Environment* ev, ODFrame* frame, FW_CString & url);
	virtual ODBoolean 	HandleCyberCommand 	(Environment* ev, long commandSuite, long command, ODFrame* frame, somToken parameters);
private:
	static ODExtension* CreateCyberExtension (Environment* ev, FW_CPart *part, const char* name, void* self);
	FW_CPart* 			fPart;
	// Once the extension is created, we will acquire it and never let go.
	// This is our only way to communicate with Cyberdog.
	FW_CAcquiredODFCyberPartExtension fExtension;
//	ODF_FW_OCyberPartExtension* fExtension;
};

#endif // _FW_MCyberPart_

