//========================================================================================
//
//	File:				Content.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef CONTENT_H
#define CONTENT_H

#ifndef DEFINES_K
#include "Defines.k"
#endif

// ----- Framework Includes -----

#ifndef FWCONTNT_H
#include "FWContnt.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class CHelloPart;

//========================================================================================
//	class CHelloContent
//========================================================================================

class CHelloContent : public FW_CContent
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	FW_DECLARE_AUTO(CHelloContent)
	
	CHelloContent(Environment* ev, CHelloPart* part);
	virtual ~CHelloContent();

//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual void		Externalize(Environment* ev,
									 ODStorageUnit* storageUnit,
									 FW_EStorageKinds storageKind,
									 FW_CCloneInfo* cloneInfo);
	virtual FW_Boolean	Internalize(Environment* ev,
									 ODStorageUnit* storageUnit, 
									 FW_EStorageKinds storageKind,
									 FW_CCloneInfo* cloneInfo);

//----------------------------------------------------------------------------------------
//	New API
//
public:
	FW_Boolean			InternalizePartKind(Environment* ev, ODStorageUnit* sourceSU);
	FW_Boolean 			InternalizeText(Environment* ev, ODStorageUnit* sourceSU);

	void				ExternalizePartKind(Environment* ev, ODStorageUnit* destinationSU);
	void				ExternalizeText(Environment* ev, ODStorageUnit* destinationSU);

	const FW_CString&	GetTextData();
	void				SetTextData(Environment* ev, const FW_CString& newText);
	void				ClearTextData(Environment* ev);

	FW_Boolean			IsTextCentered();
	void				CenterText(Environment* ev, FW_Boolean state);

//----------------------------------------------------------------------------------------
//	Data Members
//
protected:
	FW_CString255		fTextData;			// part content
	FW_Boolean			fCentered;			// part setting
	CHelloPart*			fHelloPart;
};

//========================================================================================
// Inlines
//========================================================================================

inline FW_Boolean CHelloContent::IsTextCentered()
{
	return fCentered;
}

#endif