//========================================================================================
//
//	File:				RadioGrp.h
//	Release Version:	$ ODF 1 $
//
//	Author:				Laurent Delamare
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef RADIOGRP_H
#define RADIOGRP_H

#ifndef DEFINES_K
#include "Defines.k"
#endif

// ----- Part Layer -----

#ifndef FWSVIEW_H
#include "FWSView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class FW_CRadioCluster;

//========================================================================================
// CRadioGroup
//========================================================================================

class CRadioGroup : public FW_CSuperView
{
public:
	FW_DECLARE_CLASS

public:		
	CRadioGroup(Environment *ev, 
				FW_CSuperView* container, 
				const FW_CRect& bounds,
				ODID viewId,
				const FW_CPoint& extent);
	virtual ~ CRadioGroup();

private:
	CRadioGroup(Environment *ev);

//----------------------------------------------------------------------------------------
// Inherited API
public:		
	// ----- Archiving -----
	static void*		Create(FW_CReadableStream& stream, FW_ClassTypeConstant type);
	static void			Destroy(void* object, FW_ClassTypeConstant type);
	virtual void		Flatten(Environment* ev, FW_CWritableStream& stream) const;
	virtual void		InitializeFromStream(Environment* ev, FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	New API
public:		
	FW_CRadioCluster*	GetRadioCluster(Environment* ev) const;
	
//----------------------------------------------------------------------------------------
//	Private data
 private:
	FW_CRadioCluster*	fRadioCluster;
};

//========================================================================================
// in-lines
//========================================================================================

inline	FW_CRadioCluster* CRadioGroup::GetRadioCluster(Environment* ev) const
{
	return fRadioCluster;
}


#endif
